/*
 * @(#)Callback.java
 *
 * Copyright (c) 2001-2002, JangHo Hwang
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 	1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 * 	2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 
 * 	3. Neither the name of the JangHo Hwang nor the names of its contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 *    $Id: Callback.java,v 1.2 2002/03/05 13:35:33 xrath Exp $ 
 */
package rath.msnm.entity;

/**
 * TrID  msn ݿ  callback Լ  Ŭν,
 * 󵵰  Ŭ̴.
 * 
 * @author Jang-Ho Hwang, rath@linuxkorea.co.kr
 * @version $Id: Callback.java,v 1.2 2002/03/05 13:35:33 xrath Exp $ 
 */
public class Callback
{
	private Class cl = null;
	private String methodName = null;
	private boolean infinite = false;
	private long creationTime;

	private Callback()
	{
		creationTime = System.currentTimeMillis();
	}

	/**
	 * ݹ޼ҵ尡  ð ȯѴ.
	 * ݹ   ð   ʴ´ٸ,
	 *  õǰų Ǵ ̱⶧,  , 
	 *  ޸𸮿 ɼ ִ. 
	 * <p>
	 * ̰ ϱϿ ð ˾Ƽ Timeout ѾѴ.
	 */
	public long getCreationTime()
	{
		return this.creationTime;
	}

	/**
	 * ѹ    ʴ  ݹԼ ƴ ȯѴ.
	 */
	public boolean isInfinite()
	{
		return this.infinite;
	}

	/**
	 *  ݹ  trId   ȣ  Ѵ.
	 */
	public void setInfinite()
	{
		this.infinite = true;
	}

	/**
	 * ݹ ޼ҵ ̸ ȯѴ.
	 */
	public String getMethodName()
	{
		return this.methodName;
	}

	/**
	 * ݹ ޼ҵ尡 ϴ Ŭ  ȯѴ.
	 */
	public Class getClassRef()
	{
		return this.cl;
	}

	/**
	 * ݹ ޼ҵ νϽ Ӱ Ѵ.
	 */
	public static Callback getInstance( String methodName, Class cl )
	{
		Callback call = new Callback();
		call.cl = cl;
		call.methodName = methodName;

		return call;
	}
};
