/*
 * @(#)MsnListener.java
 *
 * Copyright (c) 2001-2002, JangHo Hwang
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 	1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * 	2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * 	3. Neither the name of the JangHo Hwang nor the names of its contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *    $Id: MsnListener.java,v 1.6 2002/03/16 17:44:30 xrath Exp $
 */
package rath.msnm.event;

import java.util.EventListener;

import rath.msnm.SwitchboardSession;
import rath.msnm.entity.MsnFriend;
import rath.msnm.ftp.VolatileTransferServer;
import rath.msnm.ftp.VolatileDownloader;
import rath.msnm.msg.MimeMessage;
/**
 * 񵿱 MSN Server ϴ ޽ ̺Ʈ
 * ó  ִ ̺Ʈ  ̴̽.
 *
 * @author Jang-Ho Hwang, rath@linuxkorea.co.kr
 * @version $Id: MsnListener.java,v 1.6 2002/03/16 17:44:30 xrath Exp $
 */
public interface MsnListener extends EventListener
{
	/**
	 * α ϷǾٴ ޽̴.
	 * ڽ α̸(ּ) г ش.
	 */
	public void loginComplete( MsnFriend own );

	/**
	 *  ʴ ̵̰ų, йȣ Ʋ ,
	 *  ̺Ʈ ߼ϰ,  ȴ.
	 * ƹư α    ߻Ǵ ̺Ʈ̴.
	 */
	public void loginError( String header );

	/**
	 * α  , ¸ ¶ ٲپ, ڽ
	 * Contact list ִ ߿ ° Online(Ȥ substate)
	 * ڵ  ޼ҵ带   ̷ ش.
	 *  ȣ  Ȯϰ   ٴ ̴.
	 * <p>
	 *  Online Contact list  ʹٸ, MsnFriend ü
	 * Map صθ ϴ. (Key loginName ϸ  )
	 */
	public void listOnline( MsnFriend friend );

	/**
	 * ڽ ContactList ִ  ߿ Ѹ ¶ ǰų
	 * ¸ Ͽ, NSκ  ޽̴.
	 */
	public void userOnline( MsnFriend friend );

	/**
	 * ڽ Foward ContactList ִ  ¶̿ ڰ
	 *  ° Ǿ NSκ  ޽̴.
	 */
	public void userOffline( String loginName );


	/**
	 *  Switchboard server ؼ ڽſ ȭû
	 * Ͽ,   session Ǿٴ  ˷ش.
	 */
	public void switchboardSessionStarted( SwitchboardSession ss );

	/**
	 * Ư  ο ڰ Ͽ ˷ش.
	 */
	public void whoJoinSession( SwitchboardSession ss, MsnFriend join );

	/**
	 * Ư ǿ ڰ BYE ϰ   ˷ش.
	 */
	public void whoPartSession( SwitchboardSession ss, MsnFriend part );

	/**
	 * Switchboard session κ Ǿ ҷ.
	 */
	public void switchboardSessionEnded( SwitchboardSession ss );

	/**
	 * Switchboard session  Ϸ ϰ SSκ  
	 * ߻ϴ ̺Ʈ̴. SwitchboardSession Session id null ̴.
	 */
	public void switchboardSessionAbandon( SwitchboardSession ss, String targetName );

	/**
	 * Ư Switchboard session typingUserڰ ޽ Էϴ
	 * ϶ ߼۵ɶ ҷ.
	 */
	public void progressTyping( SwitchboardSession ss,
		MsnFriend friend, String typingUser );

	/**
	 * Ư Switchboard session νƮ ޽ ޾ ҷ.
	 *
	 * @param  ss   ش switchboard session
	 * @param  msg
	 */
	public void instantMessageReceived( SwitchboardSession ss,
		MsnFriend friend, MimeMessage mime );

	/**
	 *  ڽſ    ˷ִ ޼ҵ̴.
	 *
	 * @param  ss       Switchboard
	 * @param  cookie  信 ʿ Ű.
	 * @param  filename  ϴ  ̸
	 * @param  filesize  ϴ  ũ(byte)
	 * @since  0.3
	 */
	public void filePosted( SwitchboardSession ss, int cookie, String filename, int filesize );

	/**
	 *  ߴ Ͽ Ͽ  Accept־ ˷ִ ޼ҵ̴.
	 *  ̺Ʈ ߻Ͽ 쿡 Ư  .
	 *   ̺Ʈ ߻ , ٷ   ϱ thread
	 *  ̸ port bindǰ   ۵ ̴.
	 */
	public void fileSendAccepted( SwitchboardSession ss, int cookie );

	/**
	 *  ߴ Ͽ Ͽ  Reject ˷ִ ޼ҵ̴.
	 *  ̺Ʈ ߻Ͽ 쿡 Ư  .
	 */
	public void fileSendRejected( SwitchboardSession ss, int cookie, String reason );

	/**
	 *   ۾ ۵Ǿ ˷ش.
	 *
	 * @param  server   ۽  ü.
	 */
	public void fileSendStarted( VolatileTransferServer server );

	/**
	 *  ٿε ۾ ۵Ǿ ˷ش.
	 *
	 * @param  downloader   ٿε thread ü.
	 */
	public void fileReceiveStarted( VolatileDownloader downloader );

	/**
	 *  ۽ϴ ܰ ߻Ͽ ˷ִ ޼ҵ̴.
	 * ·,   thread ȴ.
	 */
	public void fileSendError( VolatileTransferServer server, Throwable e );

	/**
	 *  ϴ ܰ ߻Ͽ ˷ִ ޼ҵ̴.
	 * ·,   thread ȴ.
	 */
	public void fileReceiveError( VolatileDownloader downloader, Throwable e );

	/**
	 *  ڽ  ˷ش. RL ϵǾǷ,
	 *  ڽ FL ϴ  ڽ ־ Ѵ.
	 *
	 * @param  friend    LoginName, FriendlyName .
	 */
	public void whoAddedMe( MsnFriend friend );

	/**
	 *  ڽ  ˷ش. RL ǹǷ,  ˷ ʿ .
	 *
	 * @param  friend    LoginName ´. FriendlyName null ̴.
	 */
	public void whoRemovedMe( MsnFriend friend );

	/**
	 * BuddyList Ǿ Serial number   , ߼۵Ǵ ̺Ʈ̴.
	 */
	public void buddyListModified();

	/**
	 *   Ͽ ߼۵Ǵ ̺Ʈ̴.
	 *
	 * @param  errorCode  κ   ڵ 
	 */
	public void addFailed( int errorCode );

	/**
	 * ģ ̸(FriendlyName) Ǿ ߼۵Ǵ ̺Ʈ̴.
	 * ڽ  ,  ̺Ʈ ߼۵Ǹ, ٸ ΰ ص
	 * ߼۵ȴ.
	 * <p>
	 *  null̶, ڱ ڽ ̸ 濡  case̴.
	 */
	public void renameNotify( MsnFriend friend );

	/**
	 * α , Synchronization value ޶, κ
	 * FL/AL/BL/RL, Group list  ް Ǵµ, ġ 
	 * ۾̹Ƿ,   UpdateǾ Ǵ ̺Ʈ̴.
	 */
	public void allListUpdated();

	/**
	 * α׾ƿ Ǿ ˷ִ ̺Ʈ̴. ݵ  α׾ƿ
	 * ˷ִ  ƴϴ. Emergency exception  NotificationProcessor
	 * Ǿ 쿡 ̺Ʈ ߻Ѵ.
	 * <p>
	 * , ᱹ connection terminateǾ ˷ִ ̴.
	 */
	public void logoutNotify();
};
